//
//  Copyright (C) 2004-2006  Autodesk, Inc.
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of version 2.1 of the GNU Lesser
//  General Public License as published by the Free Software Foundation.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

#include "ApplicationException.cpp"
#include "ArgumentOutOfRangeException.cpp"
#include "ArrayTypeMismatchException.cpp"
#include "AuthenticationFailedException.cpp"
#include "ClassNotFoundException.cpp"
#include "ConfigurationException.cpp"
#include "ConfigurationLoadFailedException.cpp"
#include "ConfigurationSaveFailedException.cpp"
#include "ConnectionFailedException.cpp"
#include "ConnectionNotOpenException.cpp"
#include "CoordinateSystemComputationFailedException.cpp"
#include "CoordinateSystemConversionFailedException.cpp"
#include "CoordinateSystemInitializationFailedException.cpp"
#include "CoordinateSystemLoadFailedException.cpp"
#include "CoordinateSystemMeasureFailedException.cpp"
#include "CoordinateSystemTransformFailedException.cpp"
#include "DateTimeException.cpp"
#include "DbException.cpp"
#include "DbXmlException.cpp"
#include "DecryptionException.cpp"
#include "DirectoryNotFoundException.cpp"
#include "DivideByZeroException.cpp"
#include "DomainException.cpp"
#include "DuplicateDirectoryException.cpp"
#include "DuplicateFileException.cpp"
#include "DuplicateGroupException.cpp"
#include "DuplicateNameException.cpp"
#include "DuplicateObjectException.cpp"
#include "DuplicateParameterException.cpp"
#include "DuplicateRepositoryException.cpp"
#include "DuplicateResourceDataException.cpp"
#include "DuplicateResourceException.cpp"
#include "DuplicateRoleException.cpp"
#include "DuplicateServerException.cpp"
#include "DuplicateSessionException.cpp"
#include "DuplicateUserException.cpp"
#include "DwfException.cpp"
#include "DwfSectionNotFoundException.cpp"
#include "DwfSectionResourceNotFoundException.cpp"
#include "EmptyFeatureSetException.cpp"
#include "EncryptionException.cpp"
#include "EndOfStreamException.cpp"
#include "EvaluationExpiredException.cpp"
#include "Exception.cpp"
#include "FdoException.cpp"
#include "FeatureServiceException.cpp"
#include "FileIoException.cpp"
#include "FileNotFoundException.cpp"
#include "GeometryException.cpp"
#include "GroupNotFoundException.cpp"
#include "IndexOutOfRangeException.cpp"
#include "InvalidArgumentException.cpp"
#include "InvalidCastException.cpp"
#include "InvalidCoordinateSystemException.cpp"
#include "InvalidCoordinateSystemTypeException.cpp"
#include "InvalidCoordinateSystemUnitsException.cpp"
#include "InvalidDwfPackageException.cpp"
#include "InvalidDwfSectionException.cpp"
#include "InvalidFeatureSourceException.cpp"
#include "InvalidIpAddressException.cpp"
#include "InvalidLicenseException.cpp"
#include "InvalidLogEntryException.cpp"
#include "InvalidMapDefinitionException.cpp"
#include "InvalidMimeTypeException.cpp"
#include "InvalidOperationException.cpp"
#include "InvalidOperationVersionException.cpp"
#include "InvalidPasswordException.cpp"
#include "InvalidPrintLayoutFontSizeUnitsException.cpp"
#include "InvalidPrintLayoutPositionUnitsException.cpp"
#include "InvalidPrintLayoutSizeUnitsException.cpp"
#include "InvalidPropertyTypeException.cpp"
#include "InvalidRepositoryNameException.cpp"
#include "InvalidRepositoryTypeException.cpp"
#include "InvalidResourceDataNameException.cpp"
#include "InvalidResourceDataTypeException.cpp"
#include "InvalidResourceNameException.cpp"
#include "InvalidResourcePathException.cpp"
#include "InvalidResourcePreProcessingTypeException.cpp"
#include "InvalidResourceTypeException.cpp"
#include "InvalidSerialNumberException.cpp"
#include "InvalidServerNameException.cpp"
#include "InvalidStreamHeaderException.cpp"
#include "IoException.cpp"
#include "LayerNotFoundException.cpp"
#include "LengthException.cpp"
#include "LicenseException.cpp"
#include "LicenseExpiredException.cpp"
#include "LogicException.cpp"
#include "LogOpenFailedException.cpp"
#include "NotFiniteNumberException.cpp"
#include "NotImplementedException.cpp"
#include "NullArgumentException.cpp"
#include "NullPropertyValueException.cpp"
#include "NullReferenceException.cpp"
#include "ObjectNotFoundException.cpp"
#include "OperationProcessingException.cpp"
#include "OutOfMemoryException.cpp"
#include "OutOfRangeException.cpp"
#include "OverflowException.cpp"
#include "ParameterNotFoundException.cpp"
#include "PathTooLongException.cpp"
#include "PermissionDeniedException.cpp"
#include "PlatformNotSupportedException.cpp"
#include "PortNotAvailableException.cpp"
#include "PrintToScaleModeNotSelectedException.cpp"
#include "RepositoryCreationFailedException.cpp"
#include "RepositoryNotFoundException.cpp"
#include "RepositoryNotOpenException.cpp"
#include "RepositoryOpenFailedException.cpp"
#include "ResourceBusyException.cpp"
#include "ResourceDataNotFoundException.cpp"
#include "ResourceNotFoundException.cpp"
#include "ResourcesException.cpp"
#include "ResourcesLoadFailedException.cpp"
#include "ResourceTagNotFoundException.cpp"
#include "RoleNotFoundException.cpp"
#include "RuntimeException.cpp"
#include "ServerNotFoundException.cpp"
#include "ServerNotOnlineException.cpp"
#include "ServiceNotAvailableException.cpp"
#include "ServiceNotSupportedException.cpp"
#include "SessionExpiredException.cpp"
#include "StreamIoException.cpp"
#include "SystemException.cpp"
#include "TemporaryFileNotAvailableException.cpp"
#include "ThirdPartyException.cpp"
#include "UnauthorizedAccessException.cpp"
#include "UnclassifiedException.cpp"
#include "UnderflowException.cpp"
#include "UriFormatException.cpp"
#include "UserNotFoundException.cpp"
#include "XmlException.cpp"
#include "XmlParserException.cpp"
