//
//  Copyright (C) 2004-2006  Autodesk, Inc.
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of version 2.1 of the GNU Lesser
//  General Public License as published by the Free Software Foundation.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

// Predefined ranges for each service
#define COREDATA_COLLECTION_ID      1000
#define COREDATA_DATA_ID            2000
#define COREDATA_EXCEPTION_ID       3000
#define COREDATA_PROPERTY_ID        4000
#define COREDATA_SYSTEM_ID          5000
#define COREDATA_UTIL_ID            6000
#define CORESERVICE_ID              7000
#define DRAWINGSERVICE_ID           8000
#define FEATURESERVICE_ID           9000
#define MAPPINGSERVICE_ID          10000
#define RENDERINGSERVICE_ID        11000
#define RESOURCESERVICE_ID         12000
#define TILESERVICE_ID             13000
#define SERVERADMIN_ID             14000
#define SITE_ID                    15000
#define CONTROLLER_ID              16000
#define COORDINATE_SYSTEM_ID       17000
#define GEOMETRY_ID                18000
#define MAPLAYER_ID                19000
#define MAPAGENT_ID                20000
#define WEBAPP_ID                  21000

// CoreData Collection
#define CoreData_Collection_Collection                     COREDATA_COLLECTION_ID+0
#define CoreData_Collection_NamedCollection                COREDATA_COLLECTION_ID+1
#define CoreData_Collection_PropertyCollection             COREDATA_COLLECTION_ID+2
#define CoreData_Collection_StringCollection               COREDATA_COLLECTION_ID+3
#define CoreData_Collection_StringPropertyCollection       COREDATA_COLLECTION_ID+4
#define CoreData_Collection_IntCollection                  COREDATA_COLLECTION_ID+5
#define CoreData_Collection_PropertyDefinitionCollection   COREDATA_COLLECTION_ID+6
#define CoreData_Collection_BatchPropertyCollection        COREDATA_COLLECTION_ID+7
#define CoreData_Collection_SerializableCollection         COREDATA_COLLECTION_ID+8

// CoreData Data
#define CoreData_Data_ByteReader                        COREDATA_DATA_ID+0
#define CoreData_Data_ByteSource                        COREDATA_DATA_ID+1
#define CoreData_Data_ByteSourceFileImpl                COREDATA_DATA_ID+2
#define CoreData_Data_ByteSourceImpl                    COREDATA_DATA_ID+3
#define CoreData_Data_ByteSourceMemoryImpl              COREDATA_DATA_ID+4
#define CoreData_Data_ByteSourceSocketStreamImpl        COREDATA_DATA_ID+5
#define CoreData_Data_Color                             COREDATA_DATA_ID+6
#define CoreData_Data_DateTime                          COREDATA_DATA_ID+7
#define CoreData_Data_ByteSink                          COREDATA_DATA_ID+8

// CoreData Exception
#define Common_Exception_MgApplicationException                             COREDATA_EXCEPTION_ID+0
#define Common_Exception_MgArgumentOutOfRangeException                      COREDATA_EXCEPTION_ID+1
#define Common_Exception_MgArrayTypeMismatchException                       COREDATA_EXCEPTION_ID+2
#define Common_Exception_MgAuthenticationFailedException                    COREDATA_EXCEPTION_ID+3
#define Common_Exception_MgClassNotFoundException                           COREDATA_EXCEPTION_ID+4
#define Common_Exception_MgConfigurationException                           COREDATA_EXCEPTION_ID+5
#define Common_Exception_MgConfigurationLoadFailedException                 COREDATA_EXCEPTION_ID+6
#define Common_Exception_MgConfigurationSaveFailedException                 COREDATA_EXCEPTION_ID+7
#define Common_Exception_MgConnectionFailedException                        COREDATA_EXCEPTION_ID+8
#define Common_Exception_MgConnectionNotOpenException                       COREDATA_EXCEPTION_ID+9
#define Common_Exception_MgCoordinateSystemComputationFailedException       COREDATA_EXCEPTION_ID+10
#define Common_Exception_MgCoordinateSystemConversionFailedException        COREDATA_EXCEPTION_ID+11
#define Common_Exception_MgCoordinateSystemMeasureFailedException           COREDATA_EXCEPTION_ID+12
#define Common_Exception_MgCoordinateSystemTransformFailedException         COREDATA_EXCEPTION_ID+13
#define Common_Exception_MgDateTimeException                                COREDATA_EXCEPTION_ID+14
#define Common_Exception_MgDbException                                      COREDATA_EXCEPTION_ID+15
#define Common_Exception_MgDbXmlException                                   COREDATA_EXCEPTION_ID+16
#define Common_Exception_MgDecryptionException                              COREDATA_EXCEPTION_ID+17
#define Common_Exception_MgDirectoryNotFoundException                       COREDATA_EXCEPTION_ID+18
#define Common_Exception_MgDivideByZeroException                            COREDATA_EXCEPTION_ID+19
#define Common_Exception_MgDomainException                                  COREDATA_EXCEPTION_ID+20
#define Common_Exception_MgDuplicateDirectoryException                      COREDATA_EXCEPTION_ID+21
#define Common_Exception_MgDuplicateFileException                           COREDATA_EXCEPTION_ID+22
#define Common_Exception_MgDuplicateGroupException                          COREDATA_EXCEPTION_ID+23
#define Common_Exception_MgDuplicateNameException                           COREDATA_EXCEPTION_ID+24
#define Common_Exception_MgDuplicateObjectException                         COREDATA_EXCEPTION_ID+25
#define Common_Exception_MgDuplicateParameterException                      COREDATA_EXCEPTION_ID+26
#define Common_Exception_MgDuplicateRepositoryException                     COREDATA_EXCEPTION_ID+27
#define Common_Exception_MgDuplicateResourceDataException                   COREDATA_EXCEPTION_ID+28
#define Common_Exception_MgDuplicateResourceException                       COREDATA_EXCEPTION_ID+29
#define Common_Exception_MgDuplicateRoleException                           COREDATA_EXCEPTION_ID+30
#define Common_Exception_MgDuplicateServerException                         COREDATA_EXCEPTION_ID+31
#define Common_Exception_MgDuplicateSessionException                        COREDATA_EXCEPTION_ID+32
#define Common_Exception_MgDuplicateUserException                           COREDATA_EXCEPTION_ID+33
#define Common_Exception_MgDwfException                                     COREDATA_EXCEPTION_ID+34
#define Common_Exception_MgDwfSectionNotFoundException                      COREDATA_EXCEPTION_ID+35
#define Common_Exception_MgDwfSectionResourceNotFoundException              COREDATA_EXCEPTION_ID+36
#define Common_Exception_MgEmptyFeatureSetException                         COREDATA_EXCEPTION_ID+37
#define Common_Exception_MgEncryptionException                              COREDATA_EXCEPTION_ID+38
#define Common_Exception_MgEndOfStreamException                             COREDATA_EXCEPTION_ID+39
#define Common_Exception_MgException                                        COREDATA_EXCEPTION_ID+40
#define Common_Exception_MgFdoException                                     COREDATA_EXCEPTION_ID+41
#define Common_Exception_MgFeatureServiceException                          COREDATA_EXCEPTION_ID+42
#define Common_Exception_MgFileIoException                                  COREDATA_EXCEPTION_ID+43
#define Common_Exception_MgFileNotFoundException                            COREDATA_EXCEPTION_ID+44
#define Common_Exception_MgGeometryException                                COREDATA_EXCEPTION_ID+45
#define Common_Exception_MgGroupNotFoundException                           COREDATA_EXCEPTION_ID+46
#define Common_Exception_MgIndexOutOfRangeException                         COREDATA_EXCEPTION_ID+47
#define Common_Exception_MgInvalidArgumentException                         COREDATA_EXCEPTION_ID+48
#define Common_Exception_MgInvalidCastException                             COREDATA_EXCEPTION_ID+49
#define Common_Exception_MgInvalidCoordinateSystemException                 COREDATA_EXCEPTION_ID+50
#define Common_Exception_MgInvalidCoordinateSystemTypeException             COREDATA_EXCEPTION_ID+51
#define Common_Exception_MgInvalidCoordinateSystemUnitsException            COREDATA_EXCEPTION_ID+52
#define Common_Exception_MgInvalidDwfPackageException                       COREDATA_EXCEPTION_ID+53
#define Common_Exception_MgInvalidDwfSectionException                       COREDATA_EXCEPTION_ID+54
#define Common_Exception_MgInvalidFeatureSourceException                    COREDATA_EXCEPTION_ID+55
#define Common_Exception_MgInvalidIpAddressException                        COREDATA_EXCEPTION_ID+56
#define Common_Exception_MgInvalidLicenseException                          COREDATA_EXCEPTION_ID+57
#define Common_Exception_MgInvalidLogEntryException                         COREDATA_EXCEPTION_ID+58
#define Common_Exception_MgInvalidMapDefinitionException                    COREDATA_EXCEPTION_ID+59
#define Common_Exception_MgInvalidOperationException                        COREDATA_EXCEPTION_ID+60
#define Common_Exception_MgInvalidPasswordException                         COREDATA_EXCEPTION_ID+61
#define Common_Exception_MgInvalidPrintLayoutFontSizeUnitsException         COREDATA_EXCEPTION_ID+62
#define Common_Exception_MgInvalidPrintLayoutPositionUnitsException         COREDATA_EXCEPTION_ID+63
#define Common_Exception_MgInvalidPrintLayoutSizeUnitsException             COREDATA_EXCEPTION_ID+64
#define Common_Exception_MgInvalidPropertyTypeException                     COREDATA_EXCEPTION_ID+65
#define Common_Exception_MgInvalidRepositoryNameException                   COREDATA_EXCEPTION_ID+66
#define Common_Exception_MgInvalidRepositoryTypeException                   COREDATA_EXCEPTION_ID+67
#define Common_Exception_MgInvalidResourceDataNameException                 COREDATA_EXCEPTION_ID+68
#define Common_Exception_MgInvalidResourceDataTypeException                 COREDATA_EXCEPTION_ID+69
#define Common_Exception_MgInvalidResourceNameException                     COREDATA_EXCEPTION_ID+70
#define Common_Exception_MgInvalidResourcePathException                     COREDATA_EXCEPTION_ID+71
#define Common_Exception_MgInvalidResourcePreProcessingTypeException        COREDATA_EXCEPTION_ID+72
#define Common_Exception_MgInvalidResourceTypeException                     COREDATA_EXCEPTION_ID+73
#define Common_Exception_MgInvalidServerNameException                       COREDATA_EXCEPTION_ID+74
#define Common_Exception_MgInvalidStreamHeaderException                     COREDATA_EXCEPTION_ID+75
#define Common_Exception_MgIoException                                      COREDATA_EXCEPTION_ID+76
#define Common_Exception_MgLayerNotFoundException                           COREDATA_EXCEPTION_ID+77
#define Common_Exception_MgLengthException                                  COREDATA_EXCEPTION_ID+78
#define Common_Exception_MgLicenseException                                 COREDATA_EXCEPTION_ID+79
#define Common_Exception_MgLicenseExpiredException                          COREDATA_EXCEPTION_ID+80
#define Common_Exception_MgLogicException                                   COREDATA_EXCEPTION_ID+81
#define Common_Exception_MgNotFiniteNumberException                         COREDATA_EXCEPTION_ID+82
#define Common_Exception_MgNotImplementedException                          COREDATA_EXCEPTION_ID+83
#define Common_Exception_MgNullArgumentException                            COREDATA_EXCEPTION_ID+84
#define Common_Exception_MgNullPropertyValueException                       COREDATA_EXCEPTION_ID+85
#define Common_Exception_MgNullReferenceException                           COREDATA_EXCEPTION_ID+86
#define Common_Exception_MgObjectNotFoundException                          COREDATA_EXCEPTION_ID+87
#define Common_Exception_MgOperationProcessingException                     COREDATA_EXCEPTION_ID+88
#define Common_Exception_MgOutOfMemoryException                             COREDATA_EXCEPTION_ID+89
#define Common_Exception_MgOutOfRangeException                              COREDATA_EXCEPTION_ID+90
#define Common_Exception_MgOverflowException                                COREDATA_EXCEPTION_ID+91
#define Common_Exception_MgParameterNotFoundException                       COREDATA_EXCEPTION_ID+92
#define Common_Exception_MgPathTooLongException                             COREDATA_EXCEPTION_ID+93
#define Common_Exception_MgPlatformNotSupportedException                    COREDATA_EXCEPTION_ID+94
#define Common_Exception_MgPortNotAvailableException                        COREDATA_EXCEPTION_ID+95
#define Common_Exception_MgPrintToScaleModeNotSelectedException             COREDATA_EXCEPTION_ID+96
#define Common_Exception_MgRepositoryCreationFailedException                COREDATA_EXCEPTION_ID+97
#define Common_Exception_MgRepositoryNotFoundException                      COREDATA_EXCEPTION_ID+98
#define Common_Exception_MgRepositoryNotOpenException                       COREDATA_EXCEPTION_ID+99
#define Common_Exception_MgRepositoryOpenFailedException                    COREDATA_EXCEPTION_ID+100
#define Common_Exception_MgResourceDataNotFoundException                    COREDATA_EXCEPTION_ID+101
#define Common_Exception_MgResourceNotFoundException                        COREDATA_EXCEPTION_ID+102
#define Common_Exception_MgResourcesException                               COREDATA_EXCEPTION_ID+103
#define Common_Exception_MgResourcesLoadFailedException                     COREDATA_EXCEPTION_ID+104
#define Common_Exception_MgRoleNotFoundException                            COREDATA_EXCEPTION_ID+105
#define Common_Exception_MgRuntimeException                                 COREDATA_EXCEPTION_ID+106
#define Common_Exception_MgServerNotFoundException                          COREDATA_EXCEPTION_ID+107
#define Common_Exception_MgServerNotOnlineException                         COREDATA_EXCEPTION_ID+108
#define Common_Exception_MgServiceNotAvailableException                     COREDATA_EXCEPTION_ID+109
#define Common_Exception_MgServiceNotSupportedException                     COREDATA_EXCEPTION_ID+110
#define Common_Exception_MgSessionExpiredException                          COREDATA_EXCEPTION_ID+111
#define Common_Exception_MgStreamIoException                                COREDATA_EXCEPTION_ID+113
#define Common_Exception_MgSystemException                                  COREDATA_EXCEPTION_ID+114
#define Common_Exception_MgTemporaryFileNotAvailableException               COREDATA_EXCEPTION_ID+115
#define Common_Exception_MgThirdPartyException                              COREDATA_EXCEPTION_ID+116
#define Common_Exception_MgUnauthorizedAccessException                      COREDATA_EXCEPTION_ID+117
#define Common_Exception_MgUnclassifiedException                            COREDATA_EXCEPTION_ID+118
#define Common_Exception_MgUnderflowException                               COREDATA_EXCEPTION_ID+119
#define Common_Exception_MgUriFormatException                               COREDATA_EXCEPTION_ID+120
#define Common_Exception_MgUserNotFoundException                            COREDATA_EXCEPTION_ID+121
#define Common_Exception_MgXmlException                                     COREDATA_EXCEPTION_ID+122
#define Common_Exception_MgXmlParserException                               COREDATA_EXCEPTION_ID+123
#define Common_Exception_MgLogOpenFailedException                           COREDATA_EXCEPTION_ID+124
#define Common_Exception_MgInvalidOperationVersionException                 COREDATA_EXCEPTION_ID+125
#define Common_Exception_MgInvalidMimeTypeException                         COREDATA_EXCEPTION_ID+126
#define Common_Exception_MgPermissionDeniedException                        COREDATA_EXCEPTION_ID+127
#define Common_Exception_MgResourceTagNotFoundException                     COREDATA_EXCEPTION_ID+128
#define Common_Exception_MgCoordinateSystemInitializationFailedException    COREDATA_EXCEPTION_ID+129
#define Common_Exception_MgEvaluationExpiredException                       COREDATA_EXCEPTION_ID+130
#define Common_Exception_MgInvalidSerialNumberException                     COREDATA_EXCEPTION_ID+131
#define Common_Exception_MgResourceBusyException                            COREDATA_EXCEPTION_ID+132
#define Common_Exception_MgCoordinateSystemLoadFailedException              COREDATA_EXCEPTION_ID+133

// CoreData Property
#define CoreData_Property_BlobProperty                    COREDATA_PROPERTY_ID+0
#define CoreData_Property_BooleanProperty                 COREDATA_PROPERTY_ID+1
#define CoreData_Property_ByteProperty                    COREDATA_PROPERTY_ID+2
#define CoreData_Property_ClobProperty                    COREDATA_PROPERTY_ID+3
#define CoreData_Property_DateTimeProperty                COREDATA_PROPERTY_ID+4
#define CoreData_Property_DoubleProperty                  COREDATA_PROPERTY_ID+5
#define CoreData_Property_FeatureProperty                 COREDATA_PROPERTY_ID+6
#define CoreData_Property_GeometryProperty                COREDATA_PROPERTY_ID+7
#define CoreData_Property_Int16Property                   COREDATA_PROPERTY_ID+8
#define CoreData_Property_Int32Property                   COREDATA_PROPERTY_ID+9
#define CoreData_Property_Int64Property                   COREDATA_PROPERTY_ID+10
#define CoreData_Property_Property                        COREDATA_PROPERTY_ID+11
#define CoreData_Property_SingleProperty                  COREDATA_PROPERTY_ID+12
#define CoreData_Property_StringProperty                  COREDATA_PROPERTY_ID+13
#define CoreData_Property_PropertyDefinition              COREDATA_PROPERTY_ID+14

// CoreData System
#define CoreData_System_Common                            COREDATA_SYSTEM_ID+0
#define CoreData_System_Disposable                        COREDATA_SYSTEM_ID+1
#define CoreData_System_Object                            COREDATA_SYSTEM_ID+2
#define CoreData_System_Ptr                               COREDATA_SYSTEM_ID+3
#define CoreData_System_Warning                           COREDATA_SYSTEM_ID+4
#define CoreData_System_MgUserInformation                 COREDATA_SYSTEM_ID+5
#define CoreData_System_CryptographyManager               COREDATA_SYSTEM_ID+6

// CoreData Util
#define CoreData_Util_Util                                COREDATA_UTIL_ID+0

// Core Service
#define CoreService_CoreService                           CORESERVICE_ID+0
#define CoreService_ServerConnection                      CORESERVICE_ID+1
#define CoreService_Service                               CORESERVICE_ID+2
#define CoreService_Stream                                CORESERVICE_ID+4
#define CoreService_MgSiteConnection                      CORESERVICE_ID+5
#define CoreService_MgConnectionProperties                CORESERVICE_ID+6
#define CoreService_MgServerInformation                   CORESERVICE_ID+7
#define CoreService_MgPackageStatusInformation            CORESERVICE_ID+8

// Drawing Service
#define DrawingService_DrawingService                     DRAWINGSERVICE_ID+0

// Feature Service
#define FeatureService_ClassDefinition                    FEATURESERVICE_ID+0
#define FeatureService_DataPropertyDefinition             FEATURESERVICE_ID+1
#define FeatureService_FeatureConnection                  FEATURESERVICE_ID+2
#define FeatureService_FeatureReader                      FEATURESERVICE_ID+3
#define FeatureService_FeatureService                     FEATURESERVICE_ID+4
#define FeatureService_FeatureServiceCommon               FEATURESERVICE_ID+5
#define FeatureService_GeometricPropertyDefinition        FEATURESERVICE_ID+6
#define FeatureService_Geometry                           FEATURESERVICE_ID+7
#define FeatureService_ObjectPropertyDefinition           FEATURESERVICE_ID+8
#define FeatureService_PropertyDefinition                 FEATURESERVICE_ID+9
#define FeatureService_PropertyDefinitionCollection       FEATURESERVICE_ID+10
#define FeatureService_SpatialContextExtentType           FEATURESERVICE_ID+11
#define FeatureService_SpatialContextReader               FEATURESERVICE_ID+12
#define FeatureService_SqlDataReader                      FEATURESERVICE_ID+13
#define FeatureService_FeatureSet                         FEATURESERVICE_ID+14
#define FeatureService_SpatialContextData                 FEATURESERVICE_ID+15
#define FeatureService_LongTransactionReader              FEATURESERVICE_ID+16
#define FeatureService_LongTransactionData                FEATURESERVICE_ID+17
#define FeatureService_RasterPropertyDefinition           FEATURESERVICE_ID+18
#define FeatureService_Raster                             FEATURESERVICE_ID+19
#define FeatureService_RasterProperty                     FEATURESERVICE_ID+20
#define FeatureService_FeatureQueryOptions                FEATURESERVICE_ID+21
#define FeatureService_FeatureAggregateOptions            FEATURESERVICE_ID+22
#define FeatureService_DataReader                         FEATURESERVICE_ID+23
#define FeatureService_FeatureCommandCollection           FEATURESERVICE_ID+24
#define FeatureService_DeleteFeatures                     FEATURESERVICE_ID+25
#define FeatureService_InsertFeatures                     FEATURESERVICE_ID+26
#define FeatureService_UpdateFeatures                     FEATURESERVICE_ID+27
#define FeatureService_FeatureSchema                      FEATURESERVICE_ID+28
#define FeatureService_FeatureSchemaCollection            FEATURESERVICE_ID+29
#define FeatureService_ClassDefinitionCollection          FEATURESERVICE_ID+30
#define FeatureService_CreateSdfParams                    FEATURESERVICE_ID+31
#define FeatureService_GwsFeatureReader                   FEATURESERVICE_ID+32

// Mapping Service
#define MappingService_MappingService                     MAPPINGSERVICE_ID+0
#define MappingService_DwfVersion                         MAPPINGSERVICE_ID+1
#define MappingService_PlotSpecification                  MAPPINGSERVICE_ID+2
#define MappingService_PrintLayout                        MAPPINGSERVICE_ID+3
#define MappingService_Layout                             MAPPINGSERVICE_ID+4
#define MappingService_MapPlot                            MAPPINGSERVICE_ID+5
#define MappingService_MapPlotCollection                  MAPPINGSERVICE_ID+6

// Rendering Service
#define RenderingService_RenderingService                 RENDERINGSERVICE_ID+0
#define RenderingService_FeatureInformation               RENDERINGSERVICE_ID+1

// Resource Service
#define ResourceService_Repository                        RESOURCESERVICE_ID+0
#define ResourceService_ResourceDefs                      RESOURCESERVICE_ID+1
#define ResourceService_ResourceDllExport                 RESOURCESERVICE_ID+2
#define ResourceService_ResourceIdentifier                RESOURCESERVICE_ID+3
#define ResourceService_ResourceMoniker                   RESOURCESERVICE_ID+4
#define ResourceService_ResourceService                   RESOURCESERVICE_ID+5
#define ResourceService_Resource                          RESOURCESERVICE_ID+6

// Tile Service
#define TileService_TileService                           TILESERVICE_ID+0

// Server Admin
#define ServerAdmin_ServerAdmin                           SERVERADMIN_ID+0

// Site Admin
#define Site_Site                                         SITE_ID+0

// Controller API
#define MapLayer_Controller                               CONTROLLER_ID+0
#define MapLayer_AdvController                            CONTROLLER_ID+1
#define MapLayer_ZcvController                            CONTROLLER_ID+2

// CoordinateSystem API
#define CoordinateSystem_CoordinateSystem                 COORDINATE_SYSTEM_ID+0
#define CoordinateSystem_CoordinateSystemFactory          COORDINATE_SYSTEM_ID+1
#define CoordinateSystem_CoordinateSystemMeasure          COORDINATE_SYSTEM_ID+2
#define CoordinateSystem_CoordinateSystemTransform        COORDINATE_SYSTEM_ID+3

// Geometry API
#define Geometry_Point                                    GEOMETRY_ID+0
#define Geometry_Envelope                                 GEOMETRY_ID+1
#define Geometry_GeometryFactory                          GEOMETRY_ID+2
#define Geometry_Coordinate                               GEOMETRY_ID+3
#define Geometry_AgfReaderWriter                          GEOMETRY_ID+4
#define Geometry_AggregateGeometry                        GEOMETRY_ID+5
#define Geometry_ArcSegment                               GEOMETRY_ID+6
#define Geometry_CloseInstruction                         GEOMETRY_ID+7
#define Geometry_CoordinateCollection                     GEOMETRY_ID+8
#define Geometry_CoordinateIterator                       GEOMETRY_ID+9
#define Geometry_Curve                                    GEOMETRY_ID+10
#define Geometry_CurvePolygon                             GEOMETRY_ID+11
#define Geometry_CurveRing                                GEOMETRY_ID+12
#define Geometry_CurveSegment                             GEOMETRY_ID+13
#define Geometry_CurveString                              GEOMETRY_ID+14
#define Geometry_GeometricDimension                       GEOMETRY_ID+15
#define Geometry_GeometricEntity                          GEOMETRY_ID+16
#define Geometry_GeometricPathInstruction                 GEOMETRY_ID+17
#define Geometry_GeometricPathIterator                    GEOMETRY_ID+18
#define Geometry_Geometry                                 GEOMETRY_ID+19
#define Geometry_GeometryCollection                       GEOMETRY_ID+20
#define Geometry_GeometryComponent                        GEOMETRY_ID+21
#define Geometry_GeometryComponentCollection              GEOMETRY_ID+22
#define Geometry_LinearRing                               GEOMETRY_ID+23
#define Geometry_LinearSegment                            GEOMETRY_ID+24
#define Geometry_LinearString                             GEOMETRY_ID+25
#define Geometry_LineToInstrution                         GEOMETRY_ID+26
#define Geometry_Measure                                  GEOMETRY_ID+27
#define Geometry_MoveToInstruction                        GEOMETRY_ID+28
#define Geometry_MultiCurvePolygon                        GEOMETRY_ID+29
#define Geometry_MultiCurveString                         GEOMETRY_ID+30
#define Geometry_MultiGeometry                            GEOMETRY_ID+31
#define Geometry_MultiLineString                          GEOMETRY_ID+32
#define Geometry_MultiPoint                               GEOMETRY_ID+33
#define Geometry_MultiPolygon                             GEOMETRY_ID+34
#define Geometry_Polygon                                  GEOMETRY_ID+35
#define Geometry_QuadToInstruction                        GEOMETRY_ID+36
#define Geometry_Region                                   GEOMETRY_ID+37
#define Geometry_Ring                                     GEOMETRY_ID+38
#define Geometry_Transform                                GEOMETRY_ID+39
#define Geometry_WktReaderWriter                          GEOMETRY_ID+40
#define Geometry_CurveSegmentCollection                   GEOMETRY_ID+41
#define Geometry_LineString                               GEOMETRY_ID+42
#define Geometry_CurveStringCollection                    GEOMETRY_ID+43
#define Geometry_LineStringCollection                     GEOMETRY_ID+44
#define Geometry_PointCollection                          GEOMETRY_ID+45
#define Geometry_PolygonCollection                        GEOMETRY_ID+46
#define Geometry_CurvePolygonCollection                   GEOMETRY_ID+47
#define Geometry_CoordinateXY                             GEOMETRY_ID+48
#define Geometry_CoordinateXYZ                            GEOMETRY_ID+49
#define Geometry_CoordinateXYZM                           GEOMETRY_ID+50
#define Geometry_CoordinateXYM                            GEOMETRY_ID+51
#define Geometry_CurveRingCollection                      GEOMETRY_ID+52
#define Geometry_LinearRingCollection                     GEOMETRY_ID+53

// MapLayer API
#define MapLayer_Map                                      MAPLAYER_ID+0
#define MapLayer_LayerGroup                               MAPLAYER_ID+1
#define MapLayer_LayerCollection                          MAPLAYER_ID+2
#define MapLayer_Layer                                    MAPLAYER_ID+3
#define MapLayer_LayerGroupCollection                     MAPLAYER_ID+4
#define MapLayer_MapCollection                            MAPLAYER_ID+5
#define MapLayer_ReadOnlyLayerCollection                  MAPLAYER_ID+6
#define MapLayer_Selection                                MAPLAYER_ID+7

// PHP MapAgent
#define MapAgent_MgHttpHeader                             MAPAGENT_ID+0
#define MapAgent_MgHttpRequest                            MAPAGENT_ID+1
#define MapAgent_MgHttpRequestParam                       MAPAGENT_ID+2
#define MapAgent_MgHttpRequestMetadata                    MAPAGENT_ID+3
#define MapAgent_MgHttpResponse                           MAPAGENT_ID+4
#define MapAgent_MgHttpResult                             MAPAGENT_ID+5
#define MapAgent_MgHttpPrimitiveValue                     MAPAGENT_ID+6

// Web application framework
#define WebApp_WebLayout                                  WEBAPP_ID+0
#define WebApp_ToolBar                                    WEBAPP_ID+1
#define WebApp_Command                                    WEBAPP_ID+2
#define WebApp_InvokeUrlCommand                           WEBAPP_ID+3
#define WebApp_SearchCommand                              WEBAPP_ID+4
#define WebApp_ContextMenu                                WEBAPP_ID+5
#define WebApp_CommandCollection                          WEBAPP_ID+6
#define WebApp_UiPane                                     WEBAPP_ID+7
#define WebApp_UiSizablePane                              WEBAPP_ID+8
#define WebApp_Widget                                     WEBAPP_ID+9
#define WebApp_NamedWidget                                WEBAPP_ID+10
#define WebApp_SeparatorWidget                            WEBAPP_ID+11
#define WebApp_CommandWidget                              WEBAPP_ID+12
#define WebApp_FlyoutWidget                               WEBAPP_ID+13
#define WebApp_WidgetCollection                           WEBAPP_ID+14
#define WebApp_TaskBar                                    WEBAPP_ID+15
#define WebApp_InformationPane                            WEBAPP_ID+16
#define WebApp_TaskPane                                   WEBAPP_ID+17
#define WebApp_UiTargetCommand                            WEBAPP_ID+18
#define WebApp_InvokeScriptCommand                        WEBAPP_ID+19
#define WebApp_BufferCommand                              WEBAPP_ID+20
#define WebApp_PrintCommand                               WEBAPP_ID+21
#define WebApp_SelectWithinCommand                        WEBAPP_ID+22
#define WebApp_MeasureCommand                             WEBAPP_ID+23
#define WebApp_ViewOptionsCommand                         WEBAPP_ID+24
#define WebApp_GetPrintablePageCommand                    WEBAPP_ID+25
#define WebApp_HelpCommand                                WEBAPP_ID+26
#define WebApp_TaskBarWidget                              WEBAPP_ID+27
