//
//  Copyright (C) 2004-2006  Autodesk, Inc.
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of version 2.1 of the GNU Lesser
//  General Public License as published by the Free Software Foundation.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

#include "Renderer.h"
#include "RS_OutputStream.h"
#include "dwfcore/OutputStream.h"

//RS_OutputStream wrapper to a DWFOutputStream
class RSDWFOutputStream : public RS_OutputStream
{
public:

    RSDWFOutputStream(DWFOutputStream* out)
    {
        m_out = out;
    }

    virtual ~RSDWFOutputStream()
    {
    }

    virtual void flush()
    {
        m_out->flush();
    }

    virtual size_t write( const void*   pBuffer,
                          size_t        nBytesToWrite
                          )
    {
        return m_out->write(pBuffer, nBytesToWrite);
    }

private:

    DWFOutputStream* m_out;
};
